package com.FranckBarbier.Java._Euclid;

public class Euclid2 {

    private long _a, _b, _gcd, _x, _y;

    public Euclid2(long a, long b) {
        if (a < 0L) {
            _a = -a;
        } else {
            _a = a;
        }
        if (b < 0L) {
            _b = -b;
        } else {
            _b = b;
        }
        if (_a == 0L) {
            _gcd = _b;
        } else {
            if (_b == 0L) {
                _gcd = _a;
            } else {
                _gcd = extended_Euclid(_a, _b);
            }
        }
    }

    private long extended_Euclid(long a, long b) {
        if (b == 0L) {
            _x = 1L;
            _y = 0L;
            return a;
        }
        _gcd = extended_Euclid(b, a % b);
        long xp = _y;
        long yp = _x - (a / b) * _y;
        _x = xp;
        _y = yp;
        return _gcd;
    }

    public long a() {
        return _a;
    }

    public long b() {
        return _b;
    }

    public long gcd() {
        return _gcd;
    }

    public long x() {
        return _x;
    }

    public long y() {
        return _y;
    }

    public static long Basic_Euclid(long a, long b) {
        if (a < 0L) {
            a = -a;
        }
        if (b < 0L) {
            b = -b;
        }
        if (a == 0L) {
            return b;
        } else {
            if (b == 0L) {
                return a;
            } else {
                return Basic_Euclid(b, a % b);
            }
        }
    }
}
