package com.FranckBarbier.Java._Euclid;

public class Euclid {

    public final long a, b, result;

    public Euclid(long a, long b) {
        assert (a >= 0L && b > 0L);
        this.a = a;
        this.b = b;
        result = _euclid(this.a, this.b);
    }

    private long _euclid(long a, long b) {
        if (b == 0L) {
            return a;
        }
        return _euclid(b, a % b);
    }

    public static void main(String[] args) {
        Euclid e = new Euclid(12L, 18L);
        System.out.println(e.result);
    }
}
